package com.jalios.jcmsplugin.hourlyReport;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.apache.log4j.Logger;

import com.jalios.jcms.analytics.metric.AbstractReportMetric;

public class HourlyReportMetric extends AbstractReportMetric{

  private static Logger logger = Logger.getLogger(HourlyReportMetric.class);
  private long[] values = new long[24];

  public long[] getValues() {
    return values;
  }
  public void setValues(long[] values) {
    this.values = values;
  }

  @Override
  public void initializeDBDataCollections() {
    //nothing to do
  }

  @Override
  public void aggregateUridData(AbstractReportMetric metric) {
    if(!( metric instanceof HourlyReportMetric)){
      return;
    }
    HourlyReportMetric hrMetric = (HourlyReportMetric) metric;
    for(int i = 0; i< 24; i++){
        setHourValue(i, getHourValue(i)+hrMetric.getHourValue(i));
    }
  }

  @Override
  public void checkAbsoluteMetrics(List<AbstractReportMetric> previousReportList) {
    // nothing to do
  }

  public void incrementCounter(Date date){
    addCounter(date, 1);
  }

  public void addCounter(Date date, long value){
    Calendar cal = Calendar.getInstance();
    cal.setTime(date);
    int calHour = cal.get(Calendar.HOUR_OF_DAY);
    setHourValue(calHour, getHourValue(calHour) + value);
  }

  public long getHourValue(int hour){
    if( hour > values.length - 1){
      return -1;
    }
    return values[hour];
  }

  private void setHourValue(int hour, long value){
    if( hour > values.length - 1){
      return;
    }
    values[hour] = value;
  }

  public void setValues(HourlyReportMetric workMetric) {
    for(int i = 0; i< 24; i++){
        setHourValue(i, workMetric.getHourValue(i));
    }
  }
}
